package com.ether.user;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Date;

/**
 * @author vmipsl
 * @date 28 nov 2011
 */
public class User
{
    public User()
    {
    }

    public User( @NotNull final String lastName, @Nullable final String firstName, @NotNull final String email, @NotNull final String password, @Nullable final UserRole role, final boolean hasAccessToBO, @Nullable final String laboratory, @Nullable final String country, @NotNull final Date creationDate )
    {
        _lastName = lastName;
        _firstName = firstName;
        _email = email;
        _password = password;
        _role = role;
        _accessToBO = hasAccessToBO;
        _laboratory = laboratory;
        _country = country;
        _creationDate = creationDate;
    }

    public User( @NotNull final String lastName, @Nullable final String firstName, @NotNull final String email, @NotNull final String pwd, @Nullable final String role, final Boolean hasAccessToBO, @Nullable final String laboratory, @Nullable final String country, @NotNull final Date date )
    {
        this( lastName, firstName, email, pwd, UserRole.valueOf( role ), hasAccessToBO, laboratory, country, date );
    }

    public Integer getId()
    {
        return _id;
    }

    public void setId( final Integer id )
    {
        _id = id;
    }

    @NotNull
    public String getLastName()
    {
        return _lastName;
    }

    public void setLastName( @NotNull final String lastName )
    {
        _lastName = lastName;
    }

    @Nullable
    public String getFirstName()
    {
        return _firstName;
    }

    public void setFirstName( @Nullable final String firstName )
    {
        _firstName = firstName;
    }

    @NotNull
    public String getEmail()
    {
        return _email;
    }

    public void setEmail( @NotNull final String email )
    {
        _email = email;
    }

    @NotNull
    public String getPassword()
    {
        return _password;
    }

    public void setPassword( @NotNull final String password )
    {
        _password = password;
    }

    @Nullable
    public UserRole getRole()
    {
        return _role;
    }

    public void setRole( @Nullable final UserRole role )
    {
        _role = role;
    }

    public boolean isAccessToBO()
    {
        return _accessToBO;
    }

    public void setAccessToBO( final boolean accessToBO )
    {
        _accessToBO = accessToBO;
    }

    @NotNull
    public Date getCreationDate()
    {
        return _creationDate;
    }

    public void setCreationDate( @NotNull final Date creationDate )
    {
        _creationDate = creationDate;
    }

    @Nullable
    public String getLaboratory()
    {
        return _laboratory;
    }

    public void setLaboratory( @Nullable final String laboratory )
    {
        _laboratory = laboratory;
    }

    @Nullable
    public String getCountry()
    {
        return _country;
    }

    public void setCountry( @Nullable final String country )
    {
        _country = country;
    }

    private Integer _id;
    @NotNull
    private String _lastName;
    @Nullable
    private String _firstName;
    @NotNull
    private String _email;
    @NotNull
    private String _password;
    @Nullable
    private UserRole _role;
    private boolean _accessToBO;
    @NotNull
    private Date _creationDate;
    @Nullable
    private String _laboratory;
    @Nullable
    private String _country;
}
